import java.awt.*;

public class Ball {
    public Ball(Point lc, int r) { loc = lc; rad = r; }

    /** position in window */
    protected Point loc;  
    /** radius of the ball */
    protected int rad;
    /** motion in the X direction */
    protected double changeInX = 0.0;
    /** motion in the Y direction */
    protected double changeInY = 0.0;
    /** color of ball */
    protected Color color = Color.blue;

    public void setColor(Color newColor) { color = newColor; }

    public void setMotion(double dx, double dy) {
        changeInX = dx; 
        changeInY = dy;
    }

    public int radius() { return rad; }

    public Point location() { return loc; }

    /** reverse the motion in the vertical direction */
    public void reflectVert() { changeInY = -changeInY; }
    /** reverse the motion in the horizontal direction */
    public void reflectHorz() { changeInX = -changeInX; }

    public void moveTo(int x, int y) { loc.move(x, y); }

    public void move() {
        loc.translate((int) changeInX, (int) changeInY);
    }

    public void paint(Graphics g) {
        g.setColor(color);
        g.fillOval(loc.x-rad, loc.y-rad, 2*rad, 2*rad);
    }
}
