import java.awt.*;
import javax.swing.*;

public class BallWorld extends JPanel {

    // Data Fields
    public static final int PANEL_WIDTH = 500;
    public static final int PANEL_HEIGHT = 300;
    private Ball aBall = new Ball(new Point(50, 50), 20);

    // Constructors : guarantee that objects are placed into 
    // a proper initial state the moment they are created 
    // with the 'new' operator.
    public BallWorld(Color ballColor) {
        aBall.setColor(ballColor);
        aBall.setMotion(3.0, 6.0);
    }

    @Override
    public void paint(Graphics g) {
        super.paint(g);
        Graphics2D g2d = (Graphics2D) g;
        aBall.paint(g);
    }

    public void run() {
        aBall.move();
        // check boundary
        Point pos = aBall.location();
        if ((pos.x < aBall.radius()) ||
            (pos.x > PANEL_WIDTH - aBall.radius()))
            aBall.reflectHorz();
        if ((pos.y < aBall.radius()) ||
            (pos.y > PANEL_HEIGHT - aBall.radius()))
            aBall.reflectVert();

        repaint();
        try {
            // wait for the graphics system 
            // to finish repainting!
            Thread.sleep(10); 
        } catch (InterruptedException e) {
            System.exit(0);
        }
    }
}
